Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkPriorityQueue Class Reference

`#include <vtkPriorityQueue.h>`

Inheritance diagram for vtkPriorityQueue:

[legend]
Collaboration diagram for vtkPriorityQueue:

[legend]
List of all members.

## Detailed Description

an list of ids arranged in priority order

Date:
  2002/12/26 18:24:21

Revision:
  1.37

vtkPriorityQueue is a general object for creating and manipulating lists of object ids (e.g., point or cell ids). Object ids are sorted according to a user-specified priority, where entries at the top of the queue have the smallest values.

This implementation provides a feature beyond the usual ability to insert and retrieve (or pop) values from the queue. It is also possible to pop any item in the queue given its id number. This allows you to delete entries in the queue which can useful for reinserting an item into the queue.

Warning:
  This implementation is a variation of the priority queue described in "Data Structures & Algorithms" by Aho, Hopcroft, Ullman. It creates a balanced, partially ordered binary tree implemented as an ordered array. This avoids the overhead associated with parent/child pointers, and frequent memory allocation and deallocation.

Created by:
  - Schroeder, Will

CVS contributions (if > 5%):
  - Schroeder, Will (53%)
  - Miller, Jim (9%)
  - Martin, Ken (7%)
  - Henderson, Amy (6%)
  - Law, Charles (5%)
  - Barre, Sebastien (5%)

CVS logs (CVSweb):
  - .`h` (`/Common/vtkPriorityQueue.h)`
  - .`cxx` (`/Common/vtkPriorityQueue.cxx)`

Definition at line 63 of file vtkPriorityQueue.h.

## Public Types
typedef vtkObject | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
void | PrintSelf (ostream &os, vtkIndent indent)
void | Allocate (const vtkIdType sz, const vtkIdType ext=1000)
void | Insert (float priority, vtkIdType id)
vtkIdType | Pop (vtkIdType location, float &priority)
vtkIdType | Pop (vtkIdType location=0)
vtkIdType | Peek (vtkIdType location, float &priority)
vtkIdType | Peek (vtkIdType location=0)
float | DeleteId (vtkIdType id)
float | GetPriority (vtkIdType id)
vtkIdType | GetNumberOfItems ()
void | Reset ()
## Static Public Methods
vtkPriorityQueue * | New ()
int | IsTypeOf (const char *type)
vtkPriorityQueue * | SafeDownCast (vtkObject *o)
## Protected Methods
| vtkPriorityQueue ()
| ~vtkPriorityQueue ()
Item * | Resize (const vtkIdType sz)
## Protected Attributes
vtkIdTypeArray * | ItemLocation
Item * | Array
vtkIdType | Size
vtkIdType | MaxId
vtkIdType | Extend

## Member Typedef Documentation

typedef vtkObject vtkPriorityQueue::Superclass

| Reimplemented from vtkObject. Definition at line 79 of file vtkPriorityQueue.h.

## Constructor & Destructor Documentation

vtkPriorityQueue::vtkPriorityQueue | ( |  | ) | `[protected]`

vtkPriorityQueue::~vtkPriorityQueue | ( |  | ) | `[protected]`

## Member Function Documentation

vtkPriorityQueue* vtkPriorityQueue::New | ( |  | ) | `[static]`

| Instantiate priority queue with default size and extension size of 1000. Reimplemented from vtkObject.

virtual const char* vtkPriorityQueue::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkObject.

int vtkPriorityQueue::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

virtual int vtkPriorityQueue::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkObject.

vtkPriorityQueue* vtkPriorityQueue::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkObject.

void vtkPriorityQueue::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) | `[virtual]`

| Methods invoked by print to print information about the object including superclasses. Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes. Reimplemented from vtkObject.

void vtkPriorityQueue::Allocate | ( | const vtkIdType | sz,
|  | const vtkIdType | ext = 1000
| ) |

| Allocate initial space for priority queue.

void vtkPriorityQueue::Insert | ( | float | priority,
|  | vtkIdType | id
| ) |

| Insert id with priority specified. The id is generally an index like a point id or cell id.

vtkIdType vtkPriorityQueue::Pop | ( | vtkIdType | location,
|  | float & | priority
| ) |

| Removes item at specified location from tree; then reorders and balances tree. The location == 0 is the root of the tree. If queue is exhausted, then a value < 0 is returned. (Note: the location is not the same as deleting an id; id is mapped to location.) BTX Referenced by DeleteId().

vtkIdType vtkPriorityQueue::Pop | ( | vtkIdType | location = 0 | ) |

| Same as above but simplified for easier wrapping into interpreted languages.

vtkIdType vtkPriorityQueue::Peek | ( | vtkIdType | location,
|  | float & | priority
| ) | `[inline]`

| Peek into the queue without actually removing anything. Returns the id and the priority. BTX Definition at line 165 of file vtkPriorityQueue.h. References Array, vtkPriorityQueue::Item::id, MaxId, vtkPriorityQueue::Item::priority, and vtkIdType.

vtkIdType vtkPriorityQueue::Peek | ( | vtkIdType | location = 0 | ) | `[inline]`

| Peek into the queue without actually removing anything. Returns the id. Definition at line 178 of file vtkPriorityQueue.h. References Array, vtkPriorityQueue::Item::id, MaxId, and vtkIdType.

float vtkPriorityQueue::DeleteId | ( | vtkIdType | id | ) | `[inline]`

| Delete entry in queue with specified id. Returns priority value associated with that id; or VTK_LARGE_FLOAT if not in queue. Definition at line 140 of file vtkPriorityQueue.h. References vtkDataArray::GetMaxId(), vtkIdTypeArray::GetValue(), id, ItemLocation, Pop(), VTK_LARGE_FLOAT, and vtkIdType.

float vtkPriorityQueue::GetPriority | ( | vtkIdType | id | ) | `[inline]`

| Get the priority of an entry in the queue with specified id. Returns priority value of that id or VTK_LARGE_FLOAT if not in queue. Definition at line 153 of file vtkPriorityQueue.h. References Array, vtkDataArray::GetMaxId(), vtkIdTypeArray::GetValue(), id, ItemLocation, vtkPriorityQueue::Item::priority, VTK_LARGE_FLOAT, and vtkIdType.

vtkIdType vtkPriorityQueue::GetNumberOfItems | ( |  | ) | `[inline]`

| Return the number of items in this queue. Definition at line 118 of file vtkPriorityQueue.h. References vtkIdType.

void vtkPriorityQueue::Reset | ( |  | ) |

| Empty the queue but without releasing memory. This avoids the overhead of memory allocation/deletion.

Item* vtkPriorityQueue::Resize | ( | const vtkIdType | sz | ) | `[protected]`

## Member Data Documentation

vtkIdTypeArray* vtkPriorityQueue::ItemLocation`[protected]`

| Definition at line 130 of file vtkPriorityQueue.h. Referenced by DeleteId(), and GetPriority().

Item* vtkPriorityQueue::Array`[protected]`

| Definition at line 131 of file vtkPriorityQueue.h. Referenced by GetPriority(), and Peek().

vtkIdType vtkPriorityQueue::Size`[protected]`

| Definition at line 132 of file vtkPriorityQueue.h.

vtkIdType vtkPriorityQueue::MaxId`[protected]`

| Definition at line 133 of file vtkPriorityQueue.h. Referenced by Peek().

vtkIdType vtkPriorityQueue::Extend`[protected]`

| Definition at line 134 of file vtkPriorityQueue.h.

The documentation for this class was generated from the following file:

- Common/vtkPriorityQueue.h